【数据结构-堆】力扣2530. 执行 K 次操作后的最大分数

给你一个下标从 0 开始的整数数组 nums 和一个整数 k 。你的 起始分数 为 0 。

在一步 操作 中:

选出一个满足 0 <= i < nums.length 的下标 i ,

将你的 分数 增加 numsi ,并且

将 numsi 替换为 ceil(numsi / 3) 。

返回在 恰好 执行 k 次操作后,你可能获得的最大分数。

向上取整函数 ceil(val) 的结果是大于或等于 val 的最小整数。

示例 1:

输入:nums = 10,10,10,10,10, k = 5

输出:50

解释:对数组中每个元素执行一次操作。最后分数是 10 + 10 + 10 + 10 + 10 = 50 。

示例 2:

输入:nums = 1,10,3,3,3, k = 3

输出:17

解释:可以执行下述操作:

第 1 步操作:选中 i = 1 ,nums 变为 1,4,3,3,3 。分数增加 10 。

第 2 步操作:选中 i = 1 ,nums 变为 1,2,3,3,3 。分数增加 4 。

第 3 步操作:选中 i = 2 ,nums 变为 1,2,1,3,3 。分数增加 3 。

最后分数是 10 + 4 + 3 = 17 。

优先队列

cpp 复制代码
class Solution{
public:
    long long maxKelements(vector<int>& nums, int k) {
        priority_queue<int> q(nums.begin(), nums.end());
        long long ans = 0;
        for(int i = 0; i < k; i++){
            int a = q.top();
            q.pop();
            ans += a;
            int b = ceil(a / 3.0);
            q.push(b);
        }
        return ans;
    }
};

这道题难度不大,实际上就是模拟,我们由于要让分数最大,所以每次要将nums中最大的数加入到ans中,我们可以使用优先队列来进行降序排序。我们这里要注意的是题目要求向上取整,使用ceil的时候由于ceil支持的是float或者double,所以我们不能直接ceil(a/3)而ceil(a/3.0),确保是浮动除法。

相关推荐
飞Link7 小时前
什么是 AirSim?一文读懂无人机仿真平台
python·算法·无人机
一去不复返的通信er9 小时前
贪心算法-合并区间(LeetCode 56)
算法·leetcode·贪心算法
Shaoshing10 小时前
LeetCode100 49. 字母异位词分组
java·算法
YFJ_mily10 小时前
第二届区块链技术与基础模型国际学术会议(BTFM2027)
算法·区块链·能源·智能系统·rdlink研发家·机器人自动化
汤姆宝库11 小时前
收官深拆:第一性原理、产业电网与未来推演
大数据·人工智能·算法
moshuying13 小时前
块扩散 + GDN 改造:Clover 把「并行生成」塞进了 Agent 的长上下文里
前端·算法
没落之王13 小时前
历史系统建模:宋初太祖太宗「再立天庭」秩序重构推演
人工智能·算法·重构
INGNIGHT13 小时前
91 · 最小调整代价(序列dp)
数据结构·算法·leetcode
moshuying13 小时前
扩散模型开始写代码、开网页了:350 亿参数,速度比 Jev 快一倍
前端·算法